import ui
import sqlite3
from datetime import datetime
import console
import dialogs
from smtplib import SMTP
from email.message import EmailMessage

db_name = 'my_product_data.db'

# メールに関する設定
maccount = '自分のメールアドレス' 
password = ''
mytitle = '株式会社○○ △△課'
myname = '山田太郎'
yourtitle = '株式会社×× ▽▽課' 
yourname = '日経次郎' 
yourmail = '送信先のメールアドレス' 

record = None

def setup():
  conn = sqlite3.connect(db_name)
  c = conn.cursor()
  c.execute('create table if not exists orders ' + 
    '(id integer primary key autoincrement, ' + 
    'product_id integer, number integer, ' + 
    'delivery varchar(255), memo text, date datetime)')
  conn.commit()
  conn.close()
  global password
  password = console.password_alert('パスワードを入力','')

def add(sender):
  if record == None:
    return
  num = console.input_alert('発注数を入力','')
  sender.superview['pids'].text += str(record[0]) + '\n'
  sender.superview['names'].text += record[1] + '\n'
  sender.superview['nums'].text += str(num) + '\n'

def delete(sender):
  console.alert('入力した商品情報をクリアしますか。','','OK')
  sender.superview['pids'].text = ''
  sender.superview['names'].text = ''
  sender.superview['nums'].text = ''

def search(sender):
  pids = sender.superview['product_id'].text
  pid = int(pids)
  conn = sqlite3.connect(db_name)
  c = conn.cursor()
  sql = "select * from product where id = ?"
  c.execute(sql, (pid,))
  global record
  record = c.fetchone()
  if record != None:
    sender.superview['info'].text = \
      str(record[0]) + ': ' + record[1] + \
      ' (' + str(record[2]) + ')\n' + record[3]
  else:
    console.alert('レコードがありません。','')
  conn.close()

def order(sender):
  console.alert('発注しますか？', '', 'OK')
  dt = dialogs.date_dialog('納品日を入力')
  if dt == None:
    return
  dts = dt.strftime("%Y/%m/%d")
  pids_data = sender.superview['pids'].text
  nums_data = sender.superview['nums'].text
  pids = pids_data.split('\n')
  nums = nums_data .split('\n')
  conn = sqlite3.connect(db_name)
  c = conn.cursor()
  tm = datetime.now().strftime("%B %d, %Y %I:%M%p")
  data = ''
  total = 0
  # ordersテーブルに記録
  for i,item in enumerate(pids):
    if item == '':
      break
    sql = "select * from product where id = ?"
    c.execute(sql, (int(item),))
    rec = c.fetchone()
    if rec != None:
      pr = rec[2] * int(nums[i])
      total += pr
      data += rec[1] + ' (' + str(rec[2]) + '円)\t' + \
        nums[i] + '個\t' + str(pr) + '円\n'
      sql = "insert into orders (product_id, " + \
        "number,delivery,date) values (?,?,?,?)"
      c.execute(sql, (pids[i], nums[i], dts, tm))
      conn.commit()
  data += ('-'*45+'\n') + '合計\t' + str(total) + '円\n'
  conn.close()
  content = yourtitle + ' ' + yourname + '様\n'
  content += '以下の商品を発注いたします。\n\n'
  content += ('-'*45) + '\n' + data + ('-'*45) + '\n'
  content += '納品日：' + dts + '\n\n'
  content += mytitle + ' ' + myname
  # メールの中身を作成する
  msg = EmailMessage()
  msg.set_content(content) # 本文の設定
  msg['Subject'] = '【発注書】' + mytitle + ' 商品注文'
  msg['From'] = maccount
  msg['To'] = yourmail  
  # SMTPサーバーに接続して、メールを送信
  with SMTP('SMTPサーバーのアドレス', ポート番号) as smtp:
    smtp.ehlo()
    smtp.starttls()
    smtp.ehlo()
    smtp.login(maccount, password)
    smtp.send_message(msg)
    smtp.quit()
    sender.superview['pids'].text = ''
    sender.superview['names'].text = ''
    sender.superview['nums'].text = ''
    console.alert('発注しました。','','OK', \
      hide_cancel_button=True)
   
def savexl(sender):
  pass
   
def qr(sender):
  pass

# main
setup()
v = ui.load_view()
v.present('full_screen')
