import ui
import sqlite3
from datetime import datetime
import console

db_name = 'my_product_data.db'

def setup():
  conn = sqlite3.connect(db_name)
  c = conn.cursor()
  sql = "create table if not exists product (id integer primary key autoincrement, name varchar(255), price integer, company varchar(255), memo text, date datetime)"
  c.execute(sql)
  conn.commit()
  conn.close()

def search(sender):
  ids = sender.superview['id'].text
  id = int(ids)
  conn = sqlite3.connect(db_name)
  c = conn.cursor()
  sql = "select * from product where id = ?"
  c.execute(sql, (id, ))
  rec = c.fetchone()
  if rec != None:
    sender.superview['id'].text = str(rec[0])
    sender.superview['name'].text = rec[1]
    sender.superview['price'].text = str(rec[2])
    sender.superview['company'].text = rec[3]
    sender.superview['memo'].text = rec[4]
  else:
    console.alert('レコードがありません。', '', 'OK', hide_cancel_button=True)
  conn.close()

def action(sender):
  ids = sender.superview['id'].text
  nm = sender.superview['name'].text
  pr = int(sender.superview['price'].text)
  cm = sender.superview['company'].text
  mm = sender.superview['memo'].text
  conn = sqlite3.connect(db_name)
  c = conn.cursor()
  if ids.isdecimal():
    id = int(ids)
    console.alert('ID=' + ids + ' のレコードを更新しますか。', '', 'OK')
    sql = "update product set name=?,price=?,company=?,memo=? where id=?"
    c.execute(sql, (nm, pr, cm, mm, id))
  else:
    console.alert('新しい商品情報を作成しますか。', '', 'OK')
    tm = datetime.now().strftime("%B %d, %Y %I:%M%p")
    sql = "insert into product (name,price,company,memo,date) values (?,?,?,?,?)"
    c.execute(sql, (nm, pr, cm, mm, tm))
    sender.superview['id'].text = ''
    sender.superview['name'].text = ''
    sender.superview['price'].text = ''
    sender.superview['company'].text = ''
    sender.superview['memo'].text = ''
  conn.commit()
  conn.close()

# main
setup()
v = ui.load_view()
v.present('full_screen')
